OGRE: Ogre::v1::EdgeData Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Ogre::v1::EdgeData Class Reference
Core » Math

This class contains the information required to describe the edge connectivity of a given set of vertices and indexes. More...

`#include <OgreEdgeListBuilder.h>`

Inheritance diagram for Ogre::v1::EdgeData:
[legend]

## Classes
struct | Edge
| Edge data. More...
struct | EdgeGroup
| A group of edges sharing the same vertex data. More...
struct | Triangle
| Basic triangle structure. More...

## Public Types
typedef vector< EdgeGroup >::type | EdgeGroupList
typedef vector< Edge >::type | EdgeList
typedef std::vector< Vector4, STLAllocator< Vector4, CategorisedAlignAllocPolicy< MEMCATEGORY_GEOMETRY > > > | TriangleFaceNormalList
| Array of 4D vector of triangle face normal, which is unit vector orthogonal to the triangles, plus distance from origin. More...
typedef vector< char >::type | TriangleLightFacingList
| Working vector used when calculating the silhouette. More...
typedef vector< Triangle >::type | TriangleList

## Public Member Functions
| EdgeData ()
EdgeData * | clone ()
void | log (Log *log)
| Debugging method. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | updateFaceNormals (size_t vertexSet, const HardwareVertexBufferSharedPtr &positionBuffer)
| Updates the face normals for this edge list based on (changed) position information, useful for animated objects. More...
void | updateTriangleLightFacing (const Vector4 &lightPos)
| Calculate the light facing state of the triangles in this edge list. More...

## Public Attributes
EdgeGroupList | edgeGroups
| All edge groups of this edge list. More...
bool | isClosed
| Flag indicate the mesh is manifold. More...
TriangleFaceNormalList | triangleFaceNormals
| All triangle face normals. More...
TriangleLightFacingList | triangleLightFacings
| Triangle light facing states. More...
TriangleList | triangles
| Main triangles array, stores all triangles of this edge list. More...

## Detailed Description

This class contains the information required to describe the edge connectivity of a given set of vertices and indexes.

Remarks
  This information is built using the EdgeListBuilder class. Note that for a given mesh, which can be made up of multiple submeshes, there are separate edge lists for when

## Member Typedef Documentation

## ◆ EdgeGroupList

typedef vector<EdgeGroup>::type Ogre::v1::EdgeData::EdgeGroupList

## ◆ EdgeList

typedef vector<Edge>::type Ogre::v1::EdgeData::EdgeList

## ◆ TriangleFaceNormalList

typedef std::vector<Vector4, STLAllocator<Vector4, CategorisedAlignAllocPolicy<MEMCATEGORY_GEOMETRY> > > Ogre::v1::EdgeData::TriangleFaceNormalList

Array of 4D vector of triangle face normal, which is unit vector orthogonal to the triangles, plus distance from origin.

Use aligned policy here because we are intended to use in SIMD optimised routines.

## ◆ TriangleLightFacingList

typedef vector<char>::type Ogre::v1::EdgeData::TriangleLightFacingList

Working vector used when calculating the silhouette.

Use std::vector<char> instead of std::vector<bool> which might implemented similar bit-fields causing loss performance.

## ◆ TriangleList

typedef vector<Triangle>::type Ogre::v1::EdgeData::TriangleList

## Constructor & Destructor Documentation

## ◆ EdgeData()

Ogre::v1::EdgeData::EdgeData | ( |  | ) |

## Member Function Documentation

## ◆ clone()

EdgeData* Ogre::v1::EdgeData::clone | ( |  | ) |

## ◆ log()

void Ogre::v1::EdgeData::log | ( | Log * | log | ) |

Debugging method.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ updateFaceNormals()

void Ogre::v1::EdgeData::updateFaceNormals | ( | size_t | vertexSet,
|  | const HardwareVertexBufferSharedPtr & | positionBuffer
| ) |  |

Updates the face normals for this edge list based on (changed) position information, useful for animated objects.

Parameters

  vertexSet | The vertex set we are updating
  positionBuffer | The updated position buffer, must contain ONLY xyz

## ◆ updateTriangleLightFacing()

void Ogre::v1::EdgeData::updateTriangleLightFacing | ( | const Vector4 & | lightPos | ) |

Calculate the light facing state of the triangles in this edge list.

Remarks
  This is normally the first stage of calculating a silhouette, i.e. establishing which tris are facing the light and which are facing away. This state is stored in the 'triangleLightFacings'.

Parameters

  lightPos | 4D position of the light in object space, note that for directional lights (which have no position), the w component is 0 and the x/y/z position are the direction.

## Member Data Documentation

## ◆ edgeGroups

EdgeGroupList Ogre::v1::EdgeData::edgeGroups

All edge groups of this edge list.

## ◆ isClosed

bool Ogre::v1::EdgeData::isClosed

Flag indicate the mesh is manifold.

## ◆ triangleFaceNormals

TriangleFaceNormalList Ogre::v1::EdgeData::triangleFaceNormals

All triangle face normals.

It should be 1:1 with triangles.

## ◆ triangleLightFacings

TriangleLightFacingList Ogre::v1::EdgeData::triangleLightFacings

Triangle light facing states.

It should be 1:1 with triangles.

## ◆ triangles

TriangleList Ogre::v1::EdgeData::triangles

Main triangles array, stores all triangles of this edge list.

Note that triangles are grouping against edge group.

The documentation for this class was generated from the following file:

- OgreEdgeListBuilder.h